<template>
  <div
    class="flex flex-col justify-between overflow-hidden rounded-lg vertical-promotion-card"
  >
    <div
      :class="{ 'image-border-theme': theme, 'image-border': !theme }"
      class="w-full image-border"
    >
      <div class="w-full h-full aspect-[560/240]">
        <img
          v-lazy="promotion.ImagePathForDisplay"
          class="object-contain w-full h-full"
          @error="handleError"
        />
      </div>
      <span v-if="theme" class="line-relative">
        <hr class="line-style" />
      </span>
    </div>
    <el-scrollbar>
      <div class="promotion-content">
        <div
          :class="{ 'text-xs': theme, 'text-base': !theme }"
          class="promotion-date-range"
        >
          {{ promotion.DateRangeForDisplay }}
        </div>
        <div class="promotion-title">
          {{ promotion.Title }} ({{ promotion.PromoCode }})
        </div>
        <div class="promotion-remark" v-html="promotion.Remark"></div>
      </div>
    </el-scrollbar>
    <div class="flex justify-center gap-[16px] p-5 pt-2">
      <el-button
        plain
        round
        type="primary"
        class="more-info promotion-button no-field-btn"
        :id = "`${ID.PROMOTION_INFO}_${ID.PROMOTION_TYPE_ID[promotion.PromotionTypeId]}_${promotion.Id}`"
        @click="onMoreInfo"
      >
        {{ $t("information") }}
      </el-button>
      <template v-if="promotion.PromotionTypeId === 10">
        <el-button
          v-if="validateLuckyWheelbutton"
          type="primary"
          class="apply promotion-button"
          round
          :disabled="isProcessing"
          :loading="isApplying && !isDialogVisible"
          @click="onClickSpinNow"
          :id = "`${ID.PROMOTION_APPLY}_${ID.PROMOTION_TYPE_ID[promotion.PromotionTypeId]}_${promotion.Id}`"
        >
          {{ $t("Spin Now") }}
        </el-button>
      </template>
      <template v-else>
        <el-button
          type="primary"
          class="apply promotion-button"
          round
          v-if="buttonApplyPromotionEnabled(promotion)"
          @click="onApplyPromotion(promotion)"
          :disabled="isProcessing"
          :loading="isApplying && !isDialogVisible"
          :id = "`${ID.PROMOTION_APPLY}_${ID.PROMOTION_TYPE_ID[promotion.PromotionTypeId]}_${promotion.Id}`"
        >
          {{ $t("apply") }}
        </el-button>
        <nuxt-link v-else-if="!authenticated" to="/login">
          <el-button type="primary" class="apply promotion-button" round
          :id = "`${ID.PROMOTION_APPLY}_${ID.PROMOTION_TYPE_ID[promotion.PromotionTypeId]}_${promotion.Id}`"
          >
            {{ $t("apply") }}
          </el-button>
        </nuxt-link>
      </template>
    </div>
  </div>
  <el-dialog
    v-model="isDialogVisible"
    top="5vh"
    custom-class="custom-dialog"
    :show-close="false"
    :before-close="onClose"
    destroy-on-close
  >
    <div class="relative custom-header">
      {{ promotion.Title }}
      <div
        :class="[
          'absolute right-7 top-4',
          { 'promotion-close-button': selectedTheme === 'black' },
        ]"
      >
        <font-awesome-icon
          class="text-[25px] cursor-pointer close-icon"
          icon="xmark"
          @click="onClose"
        />
      </div>
    </div>
    <div class="custom-content px-[40px] pt-[40px]">
      <div class="flex dialog-border-bottom pb-[20px] gap-[20px]">
        <div
          class="w-[var(--promotion-dialog-image-width)] h-[var(--promotion-dialog-image-height)] rounded-lg overflow-hidden"
        >
          <img
            v-lazy="promotion.ImagePathForDisplay"
            class="object-contain w-full h-full"
            @error="handleError"
          />
        </div>
        <div class="flex flex-col w-[320px]">
          <div class="promotion-dialog-date-range">
            {{ promotion.DateRangeForDisplay }}
          </div>
          <div class="promotion-dialog-title">
            {{ promotion.Title }} ({{ promotion.PromoCode }})
          </div>
          <div class="promotion-dialog-remark" v-html="promotion.Remark"></div>
          <div v-if="selectedTheme === 'black'" class="py-[20px] text-center">
            <template v-if="promotion.PromotionTypeId === 10">
              <el-button
                v-if="validateLuckyWheelbutton"
                type="primary"
                class="apply promotion-button"
                round
                :disabled="isProcessing"
                :loading="isApplying && !isDialogVisible"
                @click="onClickSpinNow"
                :id = "`${ID.PROMOTION_APPLY}_${ID.PROMOTION_TYPE_ID[promotion.PromotionTypeId]}_${promotion.Id}`"
              >
                {{ $t("Spin Now") }}
              </el-button>
            </template>
            <template v-else>
              <nuxt-link v-if="!authenticated" to="/login">
                <el-button type="secondary" class="apply promotion-button" round
                :id = "`${ID.PROMOTION_APPLY}_${ID.PROMOTION_TYPE_ID[promotion.PromotionTypeId]}_${promotion.Id}`"
                >
                  {{ $t("apply") }}
                </el-button>
              </nuxt-link>
              <el-button
                v-else-if="buttonApplyPromotionEnabled(promotion)"
                type="secondary"
                class="apply promotion-button"
                round
                @click="onApplyPromotion(promotion)"
                :loading="isProcessing && isApplying"
                :id = "`${ID.PROMOTION_APPLY}_${ID.PROMOTION_TYPE_ID[promotion.PromotionTypeId]}_${promotion.Id}`"
              >
                {{ $t("apply") }}
              </el-button>
            </template>
          </div>
        </div>
      </div>
    </div>
    <div
      :class="[
        'pt-[20px] px-[40px]',
        { 'pb-[40px]': selectedTheme === 'black' },
      ]"
    >
      <el-scrollbar max-height="300px">
        <div class="promotion-content fc-text4" v-html="promotion.Content"></div>
      </el-scrollbar>
    </div>
    <div
      v-if="selectedTheme !== 'black'"
      class="flex pt-[40px] pb-[28px] justify-center gap-[16px]"
    >
      <el-button
        plain
        round
        type="primary"
        class="close promotion-button no-field-btn"
        @click="onClose"
      >
        {{ $t("close") }}
      </el-button>
      <el-button
        v-if="validateLuckyWheelbutton"
        type="primary"
        class="apply promotion-button"
        round
        :disabled="isProcessing"
        :loading="isApplying && !isDialogVisible"
        @click="onClickSpinNow"
        :id = "`${ID.PROMOTION_APPLY}_${ID.PROMOTION_TYPE_ID[promotion.PromotionTypeId]}_${promotion.Id}`"
      >
        {{ $t("Spin Now") }}
      </el-button>
      <template v-else>
        <nuxt-link v-if="!authenticated" to="/login">
          <el-button type="primary" class="apply promotion-button"
          :id = "`${ID.PROMOTION_APPLY}_${ID.PROMOTION_TYPE_ID[promotion.PromotionTypeId]}_${promotion.Id}`"
          round>
            {{ $t("apply") }}
          </el-button>
        </nuxt-link>
        <el-button
          v-else-if="buttonApplyPromotionEnabled(promotion)"
          type="primary"
          class="apply promotion-button"
          round
          @click="onApplyPromotion(promotion)"
          :loading="isProcessing && isApplying"
          :id = "`${ID.PROMOTION_APPLY}_${ID.PROMOTION_TYPE_ID[promotion.PromotionTypeId]}_${promotion.Id}`"
        >
          {{ $t("apply") }}
        </el-button>
      </template>
    </div>
  </el-dialog>
</template>
<script lang="ts">
import { IPromotion } from "@/models/promotion/promotion";
import { store } from "@/store";
import { computed, defineComponent, PropType, ref } from "vue";
import { ID } from "~~/utils/constants";

export default defineComponent({
  name: "VerticalPromotionCard",
  props: {
    promotion: {
      type: Object as PropType<IPromotion>,
      required: true,
    },
    authenticated: {
      type: Boolean,
      default: false,
    },
    onApplyPromotion: {
      type: Function,
      required: true,
    },
    isProcessing: {
      type: Boolean,
      default: false,
    },
    buttonApplyPromotionEnabled: {
      type: Function,
      required: true,
    },
    theme: {
      type: Boolean,
      required: false,
    },
    isApplying: {
      type: Boolean,
      required: false,
    },
    onClickSpinNow: {
      type: Function,
      required: true,
    },
    validateLuckyWheelbutton: {
      type: Boolean,
      required: true,
    },
  },
  setup(props) {
    const selectedTheme = computed(() => store.state.selectedThemeName);
    const isDialogVisible = ref(false);
    const onMoreInfo = () => {
      isDialogVisible.value = true;
    };
    const route = useRoute();
    const router = useRouter();
    const onClose = () => {
      isDialogVisible.value = false;
      router.push('/promotion')
    };
    const handleError = () => {
      // console.error("error");
    };
    watch(() => route.params, () => {
      isDialogVisible.value = Number(route.params.id) === props.promotion.Id;
    }, {deep: true, immediate: true});
    return {
      isDialogVisible,
      onMoreInfo,
      handleError,
      onClose,
      selectedTheme,
    };
  },
});
</script>
<style lang="scss">
:root {
  --promotion-card-height: 380px;
  --promotion-card-width: 392px;
  --promotion-image-border-color: var(--hint);
  --promotion-card-background: var(--background5);
  --promotion-more-info-button-color: var(--primary);
  --promotion-more-info-active-button-color: var(--text);
  --promotion-apply-button-color: var(--primary);
  --promotion-apply-button-text-color: var(--textBtn);
  --promotion-close-button-color: var(--failure);
  --promotion-font-color: var(--text);
  --promotion-button-width: 172px;
  --promotion-date-range-color: var(--primary);
  --promotion-title-color: var(--text5);
  --promotion-remark-color: var(--text5);
  --promotion-dialog-background: var(--background5);
  --promotion-dialog-header-background: var(--background1);
  --promotion-dialog-image-width: 392px;
  --promotion-dialog-image-height: 168px;
  --promotion-dialog-width: 812px;
  --promotion-dialog-content-color: var(--text2);
  --promotion-dialog-close-icon: var(--border);
  --promotion-dialog-border-button: var(--primary);
}
.close-icon {
  color: var(--textBtn);
}
.vertical-promotion-card {
  min-height: var(--promotion-card-height);
  height: 100%;
  background-color: var(--promotion-card-background);

  .image-border {
    border-bottom: 2px solid var(--primary);
  }
  .image-border-theme {
    border-bottom: 6px solid var(--primary);
  }
  .promotion-date-range {
    padding: 23.7px 16px 0px 16px;
    color: var(--promotion-date-range-color);
    font-weight: 400;
    letter-spacing: 0.02em;
  }
  .promotion-title {
    padding: 8px 16px 0px 16px;
    color: var(--promotion-title-color);
    font-weight: 700;
    font-size: 20px;
    line-height: 23px;
    letter-spacing: 0.02em;
  }
  .promotion-remark {
    padding: 8px 16px 0px 16px;
    font-size: 14px;
    line-height: 20px;
    letter-spacing: 0.02em;
    color: var(--promotion-remark-color);
    word-break: break-word;
  }
}
.promotion-button {
  width: var(--promotion-button-width);

  span {
    font-weight: 700;
    pointer-events: none;
  }
}
.close.el-button.el-button--primary.is-plain {
  --el-button-text-color: var(--text5);
  --el-button-border-color: var(--text5);
  --el-button-hover-bg-color: var(--promotion-more-info-active-button-color);
  --el-button-hover-border-color: var(
    --promotion-more-info-active-button-color
  );
  --el-button-active-border-color: var(
    --promotion-more-info-active-button-color
  );
  --el-button-hover-text-color: var(--promotion-close-button-color);
  --el-button-active-text-color: var(--promotion-close-button-color);
}
.more-info.el-button.el-button--primary.is-plain {
  --el-button-text-color: var(--promotion-more-info-button-color);
  --el-button-border-color: var(--promotion-more-info-button-color);
  --el-button-hover-bg-color: var(--promotion-more-info-active-button-color);
  --el-button-hover-border-color: var(
    --promotion-more-info-active-button-color
  );
  --el-button-active-border-color: var(
    --promotion-more-info-active-button-color
  );
  --el-button-hover-text-color: var(--promotion-more-info-button-color);
  --el-button-active-text-color: var(--promotion-more-info-button-color);
}
.apply.el-button.el-button--primary {
  --primary: var(--promotion-more-info-button-color);
  --el-button-text-color: var(--promotion-apply-button-text-color);
}
.promotion-dialog-date-range {
  padding: 0px;
  color: var(--promotion-date-range-color);
  font-size: 16px;
  font-weight: 400;
  letter-spacing: 0.02em;
}
.promotion-dialog-title {
  padding: 8px 0px 0px 0px;
  color: var(--promotion-title-color);
  font-weight: 700;
  font-size: 20px;
  line-height: 23px;
  letter-spacing: 0.02em;
}
.promotion-dialog-remark {
  padding: 8px 0px 0px 0px;
  font-size: 14px;
  line-height: 20px;
  letter-spacing: 0.02em;
  color: var(--text5);
}
.el-overlay-dialog:has(.custom-dialog.el-dialog) {
  display: flex;
}
.custom-dialog.el-dialog {
  --el-dialog-width: var(--promotion-dialog-width);
  border-radius: 15px;
  overflow: hidden;
  margin: auto;
}
.custom-dialog {
  .el-dialog__header {
    padding: 0;
  }
  .el-dialog__body {
    padding: 0;
    background: var(--promotion-dialog-background);

    .dialog-border-bottom {
      border-bottom: 1px solid var(--promotion-dialog-border-button);
    }
  }
  .el-scrollbar {
    max-height: 300px;
    height: auto;

    .el-scrollbar__wrap {
      height: auto;
    }
  }
}
.custom-header {
  display: flex;
  justify-content: center;
  align-items: center;
  padding: 12px 0px;
  font-size: 20px;
  font-weight: 700;
  color: var(--textBtn);
  background: var(--primary);
}
.line-relative {
  position: relative;
  bottom: 5px;
}
.line-style {
  height: 9px;
  background-color: var(--primary);
  margin: 0 130px;
  border-color: var(--primary);
  border-radius: 5px;
  border-width: 5px;
}
.promotion-close-button {
  background: #fff;
  width: 30px;
  display: flex;
  text-align: center;
  justify-content: center;
  height: 30px;
  border-radius: 50%;
  right: 0.75rem;
  top: 0.75rem;
}
.promotion-close-button svg {
  height: auto;
  color: var(--primary);
}
.apply.promotion-button.is-disabled {
  opacity: 1 !important;
}
</style>
